package mdd.client;

import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.control.TextField;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;

public class Connectable extends Group {
    private Circle _border;
    private Circle _circle;
    private boolean _connected = false;
    private boolean _optimizable = false;

    public Connectable(){
        _border = new Circle(0,0, 7);
        _border.setFill(Color.BLACK);
        _circle = new Circle(0,0,5);
        _circle.setFill(Color.WHITE);

        _circle.setOnMouseClicked(new EventHandler<MouseEvent>()
        {
            @Override
            public void handle(MouseEvent e) {
                if(e.getButton() == MouseButton.SECONDARY) {
                    if (!_connected){
                        _optimizable = !_optimizable;
                        updateCircle();
                    }
                }

            }
        });

        getChildren().addAll(_border, _circle);
    }

    private void updateCircle(){
        if (_connected){
            _circle.setFill(Color.YELLOW);
        } else if (_optimizable) {
            _circle.setFill(Color.GREEN);
        } else {
            _circle.setFill(Color.WHITE);
        }
    }

}
