package mdd.client;

import javafx.geometry.Insets;
import javafx.geometry.Point2D;
import com.sun.javafx.geom.RoundRectangle2D;
import javafx.scene.Group;
import javafx.scene.control.Label;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import org.json.JSONObject;


public class Module extends Group {
    private boolean _dragged = false;
    private Point2D _old_pos;
    private Point2D _pos = new Point2D(0.0f,0.0f);

    public Module(){
        Rectangle titlebar;
        Rectangle background;
        Text caption;
        VBox inputs = new VBox(new Input(), new Input(), new Input());
        VBox outputs = new VBox(new Output(), new Output(), new Output());

        inputs.setSpacing(10);

        outputs.setSpacing(10);


        HBox hbox = new HBox(inputs, outputs);
        hbox.setSpacing(20);
        hbox.setTranslateX(-7);
        hbox.setTranslateY(30);

        System.out.println(hbox.getPrefWidth());

        //JSONObject parameters
        titlebar = new Rectangle(0.0f, 0.0f, 150-20, 20.0f);
        titlebar.setArcWidth(10.0f);
        titlebar.setArcHeight(10.0f);
        titlebar.setFill(Color.ROYALBLUE);
        background = new Rectangle(0.0f, 0.0f, 150-20, 150 + 40);
        background.setArcWidth(10.0f);
        background.setArcHeight(10.0f);
        background.setFill(Color.GRAY);
        caption = new Text("TEST");
        caption.setFont(new Font("Arial", 15));
        caption.setFill(Color.WHITE);
        caption.setX(10);
        caption.setY(15);


        getChildren().addAll( background, titlebar, caption, hbox);

        addEventFilter(MouseEvent.MOUSE_CLICKED, e -> {
            if(e.getButton() == MouseButton.PRIMARY) {

            }
            if(e.getButton() == MouseButton.SECONDARY) {

            }
        });

        addEventFilter(MouseEvent.MOUSE_PRESSED, e -> {
            System.out.println("[Module]: press event detected!");
            if(e.getButton() == MouseButton.PRIMARY) {
                if (!_dragged){
                    _old_pos = new Point2D(e.getSceneX(), e.getSceneY());
                }
            }
            if(e.getButton() == MouseButton.SECONDARY) {

            }
        });

        addEventFilter(MouseEvent.MOUSE_DRAGGED, e -> {
            //System.out.println("[Module]: dragg event detected!");
            if(e.getButton() == MouseButton.PRIMARY) {
                _dragged = true;
            }
            if(e.getButton() == MouseButton.SECONDARY) {

            }
        });

        addEventFilter(MouseEvent.MOUSE_RELEASED, e -> {
            System.out.println("[Module]: release event detected!");
            if(e.getButton() == MouseButton.PRIMARY) {
                _dragged = false;
                System.out.print("[Module]: got: "); System.out.print(e.getSceneX()); System.out.print(" | "); System.out.print(e.getSceneY());
                System.out.println();
                _pos = new Point2D(_pos.getX()+ e.getSceneX() - _old_pos.getX(), _pos.getY() + e.getSceneY() - _old_pos.getY());
                setTranslateX(_pos.getX());
                setTranslateY(_pos.getY());
            }
            if(e.getButton() == MouseButton.SECONDARY) {

            }
        });
    }
}
